<?php
/**
*
* @package hcode: code sintax highlighter
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\hcode\acp;

class hcode_module
{
	protected $config;
	protected $cache;
	protected $phpbb_container;
	protected $config_text;
	protected $request;
	protected $template;
	protected $user;

	public	$u_action;

	function main($id, $mode)
	{
		global $cache, $config, $config_text, $db, $user, $auth, $template, $request;
		global $phpbb_root_path, $phpEx, $phpbb_admin_path, $phpbb_container;

		$this->config = $config;
		$this->config_text = $config_text;
		$this->cache = $cache;
		$this->request = $request;
		$this->template = $template;
		$this->user = $user;

		$this->page_title = 'ACP_HCODE';
		$this->tpl_name = 'acp_hcode';
		
		$submit = (isset($_POST['submit'])) ? true : false;
		$form_key = 'config_hcode';
		add_form_key($form_key);
		$error = array();

		$display_vars = array(
			'title'	=> 'ACP_HCODE',
			'vars'	=> array(
				'legend1'				=> 'ACP_HCODE_HIGHLIGHT',
				'hcode_highlightjs'		=> array('lang' => 'ACP_HCODE_HIGHLIGHTJS', 'validate' => 'text', 'type' => 'textarea:20:40', 'explain' => true),
				'hcode_auto'			=> array('lang' => 'ACP_HCODE_AUTO', 'validate' => 'string',	'type' => 'text:40:40', 'explain' => true),

				'legend2'				=> 'ACP_HCODE_DEFAULTS',
				'hcode_expand'			=> array('lang' => 'ACP_HCODE_EXPAND', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'hcode_linenums'		=> array('lang' => 'ACP_HCODE_LINENUMS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'hcode_wrap'			=> array('lang' => 'ACP_HCODE_WRAP', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),

				'legend3'				=> 'ACP_HCODE_STYLE_PROSILVER',
				'hcode_prosilver_code_open'		=> array('lang' => 'ACP_HCODE_PROSILVER_CODE_OPEN', 'validate' => 'string',	'type' => 'text:40:255', 'explain' => true),
				'hcode_prosilver_code_close'	=> array('lang' => 'ACP_HCODE_PROSILVER_CODE_CLOSE', 'validate' => 'string',	'type' => 'text:40:255', 'explain' => true),
				'hcode_prosilver'		=> array('lang' => 'ACP_HCODE_PROSILVER', 'validate' => 'text', 'type' => 'textarea:30:40', 'explain' => true),

				'legend4'				=> 'ACP_HCODE_STYLE_SUBSILVER2',
				'hcode_subsilver2_code_open'	=> array('lang' => 'ACP_HCODE_SUBSILVER2_CODE_OPEN', 'validate' => 'string',	'type' => 'text:40:255', 'explain' => true),
				'hcode_subsilver2_code_close'	=> array('lang' => 'ACP_HCODE_SUBSILVER2_CODE_CLOSE', 'validate' => 'string',	'type' => 'text:40:255', 'explain' => true),
				'hcode_subsilver2'		=> array('lang' => 'ACP_HCODE_SUBSILVER2', 'validate' => 'text', 'type' => 'textarea:30:40', 'explain' => true),
				
				'legend5'				=> 'ACP_HCODE_HLJS',
				'hcode_hljs_script'		=> array('lang' => 'ACP_HCODE_HLJS_SCRIPT', 'validate' => 'text', 'type' => 'textarea:30:40', 'explain' => true),

				'legend6'				=> 'ACP_SUBMIT_CHANGES',
			),
		);
						
		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		if (!function_exists('display_custom_bbcodes'))
		{
			include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		}

		if (!class_exists('parse_message'))
		{
			include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		}
		
		$config_text = $phpbb_container->get('config_text');

		$hcode_config_text_keys = array();
		$hcode_config_keys = array();

		foreach ( $display_vars['vars'] as $varname => $vararray )
		{
			if ( !is_array($vararray) ) continue;
			if ( $vararray['validate'] == 'text' )
			{
				$hcode_config_text_keys[] = $varname;
			}
			else
			{
				$hcode_config_keys[] = $varname;
			}
		}

		$hcode_config_text_values = array();
		foreach ( $hcode_config_text_keys as $key => $value)
		{
			$data = $config_text->get_array(array($value));
			$hcode_config_text_values[$value] = $data[$value];
		}

		$hcode_config_values = array();
		foreach ( $hcode_config_keys as $key => $value)
		{
			$hcode_config_values[$value] = $this->config[$value];
		}

		if (!sizeof($error) && $this->request->is_set_post('submit'))
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang('FORM_INVALID');
			}
			else
			{
				foreach ( $hcode_config_text_values as $key => $value)
				{
					$new_value = $request->variable(array('config',$key),'',true);
					if ( (string) $new_value !== (string) $value )
					{
						$value = $hcode_config_text_values[$key] = $new_value;
						if ( empty($value) )
						{
							switch ($key)
							{
								case 'hcode_highlightjs':
								case 'hcode_prosilver':
								case 'hcode_subsilver2':
								case 'hcode_hljs_script':
								{
									$value = $hcode_config_text_values[$key] = htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.str_replace('hcode_','',$key).'.inc'));
									break;
								}
							}
						}
						$config_text->set_array(array(
							$key => $value,
						));
					}
				}

				foreach ( $hcode_config_values as $key => $value)
				{
					$new_value = $request->variable(array('config',$key),'',true);
					if ( (string) $new_value !== (string) $value )
					{
						$value = $hcode_config_values[$key] = $new_value;
						if ( empty($value) )
						{
							switch ($key)
							{
								case 'hcode_prosilver_code_open':
								case 'hcode_prosilver_code_close':
								case 'hcode_subsilver2_code_open':
								case 'hcode_subsilver2_code_close':
								{
									$value = $hcode_config_values[$key] = htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.str_replace('hcode_','',$key).'.inc'));
									break;
								}
								case 'hcode_auto':
								{
									$value = $hcode_config_values[$key] = '[]';
									break;
								}
							}
						}
						set_config($key,$value);
					}
				}
			}

			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$new_config = array_merge($hcode_config_text_values,$hcode_config_values);

		$this->page_title = $display_vars['title'];
		
		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'L_TITLE_DESCRIPTION'	=> $user->lang[$display_vars['title'] . '_DESCRIPTION'],

			'S_ERROR'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'			=> implode('<br />', $error),
		));
		
		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$l_description = (isset($user->lang[$vars['lang'] . '_DESCRIPTION'])) ? $user->lang[$vars['lang'] . '_DESCRIPTION'] : '';

			$content = build_cfg_template($type, $config_key, $new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'TITLE_DESCRIPTION'	=> $l_description,
				'CONTENT'		=> $content,
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>