function hcodeselectCode(a) {
	'use strict';

	// Get ID of code block
	var e;
	try {
		e = a.parentNode.nextSibling.firstChild.firstChild.rows[0].cells[1];
	} catch(err) {
		e = a.parentNode.parentNode.getElementsByTagName('CODE')[0];
	}
	var s, r;

	// Not IE and IE9+
	if (window.getSelection) {
		s = window.getSelection();
		// Safari and Chrome
		if (s.setBaseAndExtent) {
			var l = (e.innerText.length > 1) ? e.innerText.length - 1 : 1;
			s.setBaseAndExtent(e, 0, e, l);
		}
		// Firefox and Opera
		else {
			// workaround for bug # 42885
			if (window.opera && e.innerHTML.substring(e.innerHTML.length - 4) === '<BR>') {
				e.innerHTML = e.innerHTML + '&nbsp;';
			}

			r = document.createRange();
			r.selectNodeContents(e);
			s.removeAllRanges();
			s.addRange(r);
		}
	}
	// Some older browsers
	else if (document.getSelection) {
		s = document.getSelection();
		r = document.createRange();
		r.selectNodeContents(e);
		s.removeAllRanges();
		s.addRange(r);
	}
	// IE
	else if (document.selection) {
		r = document.body.createTextRange();
		r.moveToElementText(e);
		r.select();
	}
}
if ( typeof selectCode === 'function' ) {
	selectCode = hcodeselectCode;
}
if (('forEach' in Array.prototype) || !document.addEventListener) {
	function expandCode(e) {
		var c = e.parentNode.nextSibling.firstChild;
		if (c.style.maxHeight == 'none') {
			c.style.maxHeight = '200px';
			e.innerHTML = hcode.lang.expand;
		}
		else {
			c.style.maxHeight = 'none';
			e.innerHTML = hcode.lang.collapse;
		}
	}
	function wrapCode(e,set) {
		var c = e.parentNode.nextSibling;
		if (set) {
			c.style.wordWrap = 'normal';
			c.style.whiteSpace = 'pre';
			e.innerHTML = hcode.lang.collapse;
		}
		else {
			if (!(c.style.wordWrap == 'normal')){
				c.style.wordWrap = 'normal';
				c.style.whiteSpace = 'pre';
				e.innerHTML = hcode.lang.collapse;
			}
			else {
				c.style.wordWrap = 'break-word';
				c.style.whiteSpace = 'pre-wrap';
				e.innerHTML = hcode.lang.expand;
				linesCode(e.previousSibling.previousSibling,true);
			}
		}
	}
	function linesCode(e,reset) {
		var c = e.parentNode.nextSibling.firstChild.firstChild;
		if (reset) {
			c.rows[0].cells[0].firstChild.style.display = 'none';
			e.innerHTML = hcode.lang.numeration_on;
		}
		else {
			if (!(c.rows[0].cells[0].firstChild.style.display == 'none')) {
				c.rows[0].cells[0].firstChild.style.display = 'none';
				e.innerHTML = hcode.lang.numeration_on;
			}
			else {
				wrapCode(e.nextSibling.nextSibling,true);
				c.rows[0].cells[0].firstChild.style.display = 'block';
				e.innerHTML = hcode.lang.numeration_off;
			}
		}
	}
	function padlinesCode(number, len) {
		var str = '' + (number+1);
		for (var i=str.length; i<=len; i++) {
			str = '0' + str;
		}
		return str;
	}
	function createlinesCode(e) {
		String.prototype.replaceAll = function(find, replace_to) {
			return this.replace(new RegExp(find, "g"), replace_to);
		}
		var code = e.innerHTML;
		if (code.charAt(code.length - 1) == '\n') code = code.slice(0, -1);
		code = code.replaceAll('\r','');
		var n = 1;
		for (var i=0; i<code.length; i++) {
			if (code.charAt(i) == '\n') n++;
		}
		var len = Math.floor(Math.log(n) / Math.log(10));
		if (len < 2) len = 2;
		var cl = '<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td class="hcodelines" width="auto"><div class="hcodelinesdiv" style="display: none;">';
		for (var i=0; i<n; i++) {
			cl += padlinesCode(i,len) + '&nbsp;\n';
		}
		cl += '</div></td><td class="hcodetd" width="100%">' + code + '</td></tr></table>';
		e.innerHTML = cl;
	}
	function highlightBlock(block,i) {
		if ( block.className && new RegExp("(^|\\s)hljs(\\s|$)").test(block.className) ) {
			return;
		}
		var hlpre = '';
		var hl = block.className;
		if ( typeof hl === "undefined" ) {
			hl = block.className = '';
		}
		var hb = false;
		switch (hl) {
			case 'no':
			case 'noh':
			case 'nohighlight':
			case 'no-highlight':
			case 'none':
			case 'off': {
				break;
			}
			case 'auto':
			case '': {
				var h = hljs.highlightAuto(block.innerHTML);
				hl = h.language;
				if ( typeof hl === 'undefined' ) {
					hl = '';
					block.className = '';
				} else
				{
					hlpre = hcode.lang.hljs_identified;
				}
				hb = true;
				break;
			}
			case 'html': {
				block.className = 'xml';
			}
			default: {
				hlpre = hcode.lang.hljs_language;
				hb = true;
				break;
			}
		}
		if ( hb ) {
			hljs.highlightBlock(block,i);
		}
		if ( hl != '' ) {
			block.parentNode.previousSibling.innerHTML += '<span class="hcoderight">' + ((hlpre == '') ? '' : (' &nbsp;|&nbsp; ' + hlpre + ': ' + hl)) + '&nbsp;</span>';
		}
		if (block.scrollHeight > block.offsetHeight + 1) {
			block.parentNode.previousSibling.innerHTML += ' &middot; <a href="#" name="expandCode_' + i + '" onclick="expandCode(this); return false;">' + hcode.lang.expand + '</a>';
		}
		block.parentNode.previousSibling.innerHTML += ' &nbsp;|&nbsp; ' + hcode.lang.lines + ':&nbsp;<a href="#" name="linesCode_' + i + '" onclick="linesCode(this,false); return false;">' + hcode.lang.numeration_on + '</a> &middot; <a href="#" name="wrapCode_' + i + '" onclick="wrapCode(this,false); return false;">' + hcode.lang.expand + '</a>';
		createlinesCode(block);
		if ( hcode.settings.expand ) {
			eexpandcode = document.getElementsByName('expandCode_' + i);
			for ( var j=0; j<eexpandcode.length; j++ ) {
				expandCode(eexpandcode[j]);
			}
		}
		if ( hcode.settings.linenums ) {
			elinescode = document.getElementsByName('linesCode_' + i);
			for ( var j=0; j<elinescode.length; j++ ) {
				linesCode(elinescode[j],false);
			}
		} else if ( hcode.settings.wrap ) {
			ewrapcode = document.getElementsByName('wrapCode_' + i);
			for ( var j=0; j<ewrapcode.length; j++ ) {
				wrapCode(ewrapcode[j],false);
			}
		}
	}
	function highlightInit() {
		if ( typeof hljs === 'undefined' ) {
			return;
		}
		var blocks = document.getElementsByTagName('code');
		for (i = 0; i < blocks.length; i++) {
			highlightBlock(blocks[i],i);
		}
	}
	if ( typeof hljs !== 'undefined' ) {
		hljs.configure({ 'languages': hcode.settings.auto });
		highlightInit();
	}
}