<?php
/**
*
* @package hcode: code sintax highlighter
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\hcode\migrations\v0xx;

class hcode_v_0_0_2 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return isset($this->config['hcode_version']) && version_compare($this->config['hcode_version'], '0.0.2', '>=');
	}

	static public function depends_on()
	{
			return array('\phpbb\db\migration\data\v310\dev');
	}

	public function update_schema()
	{
		return array(
		);
	}

	public function revert_schema()
	{
		return array(
		);
	}

	public function update_data()
	{
		global $phpbb_root_path;

		return array(
			// Current version
			array('config.add', array('hcode_version', '0.0.2')),

			// Add configs
			array('config_text.add', array('hcode_highlightjs', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'highlightjs.inc')))),
			array('config.add', array('hcode_auto', '[\'xml\']')),

			array('config.add', array('hcode_expand', '0')),
			array('config.add', array('hcode_linenums', '0')),
			array('config.add', array('hcode_wrap', '0')),

			array('config.add', array('hcode_prosilver_code_open', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'prosilver_code_open.inc')))),
			array('config.add', array('hcode_prosilver_code_close', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'prosilver_code_close.inc')))),
			array('config_text.add', array('hcode_prosilver', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'prosilver.inc')))),

			array('config.add', array('hcode_subsilver2_code_open', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'subsilver2_code_open.inc')))),
			array('config.add', array('hcode_subsilver2_code_close', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'subsilver2_code_close.inc')))),
			array('config_text.add', array('hcode_subsilver2', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'subsilver2.inc')))),

			array('config_text.add', array('hcode_hljs_script', htmlspecialchars(file_get_contents(realpath($phpbb_root_path).DIRECTORY_SEPARATOR.'ext'.DIRECTORY_SEPARATOR.'c61'.DIRECTORY_SEPARATOR.'hcode'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'hljs_script.inc')))),

			// Add ACP modules
			array('module.add', array('acp', 'ACP_CAT_DOT_MODS', 'ACP_HCODE')),
			array('module.add', array('acp', 'ACP_HCODE', array(
					'module_basename'	=> '\c61\hcode\acp\hcode_module',
					'module_langname'	=> 'ACP_HCODE_EXPLAIN',
					'module_mode'		=> 'config_hcode',
					'module_auth'		=> 'acl_a_hcode',
			))),
			
			// Add permissions
			array('permission.add', array('a_hcode', true)),

			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_hcode')),
		);
	}

}